#encoding: utf-8
module InovadoraXml
  module Modules
    module GeradorXml

      def elemento(elemento, valor = nil)
        if valor.class == String
          valor.strip!
          valor = I18n.transliterate(valor)
          regex = /[^a-zA-Z0-9,.\-_\/:\[\]\=\$\@\{\}\/\n ]/
          #regex = /[^a-zA-Z0-9,.\-_\/:\[\]\=\$\@\{\}\/ ]/
          valor = valor.gsub(regex, "")
        end
        self.xml_nfse.send(elemento, valor) {
          yield if block_given?
        } unless valor.nil?
      end

      def grupo(elemento, id = nil)
        if id.present?
          self.xml_nfse.send(elemento, id) {
            yield if block_given?
          }
        else
          self.xml_nfse.send(elemento) {
            yield if block_given?
          }
        end
      end

      def construir(elemento_raiz)
        builder = Nokogiri::XML::Builder.new() do |xml|
          self.xml_nfse = xml
          elemento(elemento_raiz, get_namespace) {
            yield
          }
        end
        xml_builder = builder.to_xml(indent: 2, encoding: "UTF-8")
        doc = Nokogiri::XML(xml_builder, &:noblanks)
        return doc
      end
    end
  end
end